
//
//  QVas3D.cpp - 3D (Quad) Vector Addition & Subtraction
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//  Created - 3 Oct 2001 - James Leiterman
//
//  Last Modification
//
//  stab=4
//



#include "KariType.h"                                   // Master Definitions

    //  3rd Party Libraries
    
#include    <assert.h>
#include    <iostream.h>

    //  Book Development Library Modules

#include    "vmp3D.h"
#include    "vmp3DEx.h"
#include    "QVas3D.h"                                  // 3D Math
#include    "QVas3DEx.h"



vmp_QVecAddProc             vmp_QVecAdd;
vmp_QVecAddProc             vmp_QVecAdd0;
vmp_QVecSubProc             vmp_QVecSub;
vmp_QVecSubProc             vmp_QVecSub0;
vmp_QVecAddScalarProc       vmp_QVecAddScalar;
vmp_QVecAddScalarProc       vmp_QVecAddScalar0;
vmp_QVecSubScalarProc       vmp_QVecSubScalar;
vmp_QVecSubScalarProc       vmp_QVecSubScalar0;



//
//  (Quad) Vector Summation (Addition)
//

void vmp_QVecAddGeneric(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB)
{   
    ASSERT_PTR4(pvD);
    ASSERT_PTR4(pvA);
    ASSERT_PTR4(pvB);

    pvD->x = pvA->x + pvB->x;
    pvD->y = pvA->y + pvB->y;
    pvD->z = pvA->z + pvB->z;
    pvD->w = pvA->w + pvB->w;
}



//
//  (Quad) Vector Difference (Subtraction)
//

void vmp_QVecSubGeneric(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB)
{   
    ASSERT_PTR4(pvD);
    ASSERT_PTR4(pvA);
    ASSERT_PTR4(pvB);

    pvD->x = pvA->x - pvB->x;
    pvD->y = pvA->y - pvB->y;
    pvD->z = pvA->z - pvB->z;
    pvD->w = pvA->w - pvB->w;
}



//
//  (Quad) Vector Scalar Summation (Addition)
//

void vmp_QVecAddScalarGeneric(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScalar)
{   
    ASSERT_PTR4(pvD);
    ASSERT_PTR4(pvA);

    pvD->x = pvA->x + fScalar;
    pvD->y = pvA->y + fScalar;
    pvD->z = pvA->z + fScalar;
    pvD->w = pvA->w + fScalar;
}



//
//  (Quad) Vector Scalar Difference (Subtraction)
//

void vmp_QVecSubScalarGeneric(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScalar)
{   
    ASSERT_PTR4(pvD);
    ASSERT_PTR4(pvA);
    
    pvD->x = pvA->x - fScalar;
    pvD->y = pvA->y - fScalar;
    pvD->z = pvA->z - fScalar;
    pvD->w = pvA->w - fScalar;
}








