  
//
//  Vsf3DEx.h - 3D Math Special Function
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to accomodate the book.
//
//      This module is designed for fast 3D math
//
//  Created - 3 Oct 2001 - James Leiterman
//
//  Last Modification
//
//  stab=4
//


#include    "vmp3D.h"
#include    "cpuAsm.h"



#ifndef __Vsf3DEx_H
#define __Vsf3DEx_H

#ifdef __cplusplus
extern "C" {
#endif


void Vsf3DSetup( const CpuInfo * const pcinfo );

void vmp_VecSqrtGeneric( vmp3DVector * const pvD, const vmp3DVector * const pvA);
void vmp_VecSqrtAsm3DNow(vmp3DVector * const pvD, const vmp3DVector * const pvA);
void vmp_VecSqrtAsmSSE(  vmp3DVector * const pvD, const vmp3DVector * const pvA);
void vmp_VecSqrtAsmSSE0( vmp3DVector * const pvD, const vmp3DVector * const pvA);

void vmp_VecSqrtFastAsm3DNow(vmp3DVector * const pvD, const vmp3DVector * const pvA);
void vmp_VecSqrtFastAsmSSE(  vmp3DVector * const pvD, const vmp3DVector * const pvA);
void vmp_VecSqrtFastAsmSSE0( vmp3DVector * const pvD, const vmp3DVector * const pvA);

void vmp_VecMinGeneric( vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB );
void vmp_VecMinAsm3DNow(vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB );
void vmp_VecMinAsmSSE(  vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB );
void vmp_VecMinAsmSSE0( vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB );

void vmp_VecMaxGeneric( vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB );
void vmp_VecMaxAsm3DNow(vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB );
void vmp_VecMaxAsmSSE(  vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB );
void vmp_VecMaxAsmSSE0( vmp3DVector * const pvD, const vmp3DVector * const pvA, const vmp3DVector * const pvB );

void vmp_VecMagnitudeGeneric( float * const pfD, const vmp3DVector * const pvA);
void vmp_VecMagnitudeAsm3DNow(float * const pfD, const vmp3DVector * const pvA);
void vmp_VecMagnitudeAsmSSE(  float * const pfD, const vmp3DVector * const pvA);
void vmp_VecMagnitudeAsmSSE0( float * const pfD, const vmp3DVector * const pvA);

void vmp_VecMagnitudeFastAsm3DNow(float * const pfD, const vmp3DVector * const pvA);
void vmp_VecMagnitudeFastAsmSSE(  float * const pfD, const vmp3DVector * const pvA);
void vmp_VecMagnitudeFastAsmSSE0( float * const pfD, const vmp3DVector * const pvA);

void vmp_VecNormalizeGeneric( vmp3DVector * const pvD, const vmp3DVector * const pvA);
void vmp_VecNormalizeAsm3DNow(vmp3DVector * const pvD, const vmp3DVector * const pvA);
void vmp_VecNormalizeAsmSSE(  vmp3DVector * const pvD, const vmp3DVector * const pvA);
void vmp_VecNormalizeAsmSSE0( vmp3DVector * const pvD, const vmp3DVector * const pvA);

void vmp_VecNormalizeFastAsm3DNow(vmp3DVector * const pvD, const vmp3DVector * const pvA);
void vmp_VecNormalizeFastAsmSSE(  vmp3DVector * const pvD, const vmp3DVector * const pvA);
void vmp_VecNormalizeFastAsmSSE0( vmp3DVector * const pvD, const vmp3DVector * const pvA);



#ifdef __cplusplus
}
#endif

#endif  //__Vsf3DEx_H


